*************************************************
*	50Khz Protracker Module replayer	*
*************************************************
* Originally converted to the STE by Lance	*
* bugfixes and optimizations by ray//.tSCc.	*
*						*
* eml: ray@tscc.de				*
* www: http://ray.tscc.de	      2003-2005 *
*************************************************

; Global equates

STE		=	0	; TT fix by ray//.tSCc. 2004
TT		=	1

MACHINE 	=	STE

DMABUFLEN	=	1000	; DMA ringbuffer length in bytes


		rsreset
n_note		rs.w	1	; Beat struct
n_cmd		rs.w	1
n_cmdlo 	=	n_cmd+1
n_start 	rs.l	1
n_length	rs.w	1
n_loopstart	rs.l	1
n_replen	rs.w	1
n_period	rs.w	1
n_finetune	rs.b	1
n_volume	rs.b	1
n_dmabit	rs.w	1
n_toneportdirec rs.b	1
n_toneportspeed rs.b	1
n_wantedperiod	rs.w	1
n_vibratocmd	rs.b	1
n_vibratopos	rs.b	1
n_tremolocmd	rs.b	1
n_tremolopos	rs.b	1
n_wavecontrol	rs.b	1
n_glissfunk	rs.b	1
n_sampleoffset	rs.b	1
n_pattpos	rs.b	1
n_loopcount	rs.b	1
n_funkoffset	rs.b	1
n_wavestart	rs.l	1
n_reallength	rs.w	1


		rsreset
mt_sample_point rs.l	1
mt_sample_end	rs.l	1
mt_loop_start	rs.l	1
mt_volume	rs.w	1
mt_period	rs.w	1
mt_add_iw	rs.w	1
mt_check_dummy	rs.w	1

		opt	a+,o+,ow-

	ifne	MACHINE
		comment HEAD=%111	; Fastram support for TTs
	else
		comment HEAD=%001	; STE -> only set Fastloadflag
	endc


		section text
mt_init
	ifne	MACHINE
		clr.w	-(sp)		; Reserve DMA buffers in ST RAM
		pea.l	2*2*DMABUFLEN.w
		move.w	#$44,-(sp)	; TT, use Mxalloc()
		trap	#1
		addq.l	#8,sp
	else
		pea.l	2*2*DMABUFLEN.w
		move.w	#$48,-(sp)	; STE, use Malloc()
		trap	#1
		addq.l	#6,sp
	endc
		lea.l	mt_physic_buf(pc),a0
		move.l	d0,(a0)+
		addi.l	#2*DMABUFLEN,d0
		move.l	d0,(a0)


		lea.l	mt_data,a0
		move.l	a0,mt_songdataptr
		move.l	a0,a1
		lea.l	952(a1),a1
		moveq.l	#127,d0
		moveq.l	#0,d1
mtloop		move.l	d1,d2

		subq.w	#1,d0
mtloop2		move.b	(a1)+,d1
		cmp.b	d2,d1
		bgt.s	mtloop

		dbra	d0,mtloop2
		addq.b	#1,d2

		lea.l	mt_samplestarts(pc),a1
		asl.l	#8,d2
		asl.l	#2,d2
		addi.l	#1084,d2
		add.l	a0,d2
		move.l	d2,a2
		moveq.l #30,d0
		moveq.l #0,d2
		lea.l	42(a0),a0

mtloop3 	clr.l	(a2)
		move.l	a2,d1
		add.l	d2,d1
		move.l	d1,(a1)+
		moveq.l #0,d1
		move.w	(a0),d1
		add.l	d1,d1
		add.l	d1,a2
		add.w	#640,d2
		tst.w	4(a0)
		bne.s	.mt_no_test
		cmp.w	#1,6(a0)
		ble.s	.mt_no_test
		subq.w	#1,6(a0)
		move.w	#1,4(a0)
.mt_no_test	add.l	#30,a0
		dbra	d0,mtloop3
		add.w	d2,a2
		lea.l	mt_module_end,a1
		move.l	a2,(a1)
		move.b	#6,mt_speed
		move.b	#6,mt_counter
		clr.b	mt_songpos
		clr.w	mt_patternpos

		lea.l	-31*640(a2),a1

		moveq.l #30,d7
mt_init_loops	sub.w	#30,a0
		lea.l	-640(a2),a2
		lea.l	(a2),a3
		move.w	(a0),d0
		beq.s	.mt_just_loop
		subq.w	#1,d0
.mt_copy_spl	move.w	-(a1),-(a2)
		dbra	d0,.mt_copy_spl

.mt_just_loop	moveq.l #0,d0
		move.w	4(a0),d0
		sne.b	d1
		andi.w	#$4,d1
		move.l	mt_loop_point(pc,d1.w),a4
		jsr	(a4)
		dbra	d7,mt_init_loops

		move.l	mt_samplestarts,a0
		move.l	mt_module_end,a1
.mt_shift_down	move.b	(a0),d0
		asr.b	#1,d0
		move.b	d0,(a0)+
		cmp.l	a0,a1
		bne.s	.mt_shift_down

		bra.w	mt_init_Paula


mt_loop_point	dc.l	.mt_no_loop
		dc.l	.mt_yes_loop

.mt_no_loop	move.w	#640/4-1,d0
.mt_clea.lr_loop		clr.l	(a3)+
		dbra	d0,.mt_clea.lr_loop
		rts
.mt_yes_loop	add.l	d0,d0
		lea.l	(a2,d0.l),a4
		lea.l	(a4),a5
		moveq.l #0,d1
		move.w	4(a0),d1
		add.w	6(a0),d1
		move.w	d1,(a0)
		add.l	d1,d1
		lea.l	(a2,d1.l),a3
		move.w	6(a0),d1
		move.w	#320-1,d2
.mt_loop_loop	move.w	(a4)+,(a3)+
		subq.w	#1,d1
		bne.s	.mt_no_restart
		lea.l	(a5),a4
		move.w	6(a0),d1
.mt_no_restart	dbra	d2,.mt_loop_loop
		rts

mt_music	movem.l d0-d4/a0-a6,-(sp)
		addq.b	#1,mt_counter
		move.b	mt_counter(pc),d0
		cmp.b	mt_speed(pc),d0
		blo.s	mt_nonewnote
		clr.b	mt_counter
		tst.b	mt_pattdeltime2
		beq.s	mt_getnewnote
		bsr.s	mt_nonewallchannels
		bra.w	mt_dskip

mt_nonewnote	bsr.s	mt_nonewallchannels
		bra.w	mt_nonewposyet

mt_nonewallchannels
		lea.l	mt_channel_0,a5
		lea.l	mt_chan1temp(pc),a6
		bsr.w	mt_checkefx
		lea.l	mt_channel_1,a5
		lea.l	mt_chan2temp(pc),a6
		bsr.w	mt_checkefx
		lea.l	mt_channel_2,a5
		lea.l	mt_chan3temp(pc),a6
		bsr.w	mt_checkefx
		lea.l	mt_channel_3,a5
		lea.l	mt_chan4temp(pc),a6
		bra.w	mt_checkefx

mt_getnewnote	move.l	mt_songdataptr(pc),a0
		lea.l	12(a0),a3
		lea.l	952(a0),a2	; Pattern position
		lea.l	1084(a0),a0	; Pattern data
		moveq.l #0,d0
		moveq.l #0,d1
		move.b	mt_songpos(pc),d0
		move.b	(a2,d0.w),d1
		asl.l	#8,d1
		asl.l	#2,d1
		add.w	mt_patternpos(pc),d1
		clr.w	mt_dmacontemp

		lea.l	mt_channel_0,a5
		lea.l	mt_chan1temp(pc),a6
		bsr.s	mt_playvoice
		lea.l	mt_channel_1,a5
		lea.l	mt_chan2temp(pc),a6
		bsr.s	mt_playvoice
		lea.l	mt_channel_2,a5
		lea.l	mt_chan3temp(pc),a6
		bsr.s	mt_playvoice
		lea.l	mt_channel_3,a5
		lea.l	mt_chan4temp(pc),a6
		bsr.s	mt_playvoice
		bra.w	mt_setdma

mt_playvoice	tst.l	(a6)
		bne.s	mt_plvskip
		bsr.w	mt_pernop
mt_plvskip	move.l	(a0,d1.l),(a6)
		addq.l	#4,d1
		moveq.l #0,d2
		move.b	n_cmd(a6),d2
		and.b	#$f0,d2
		lsr.b	#4,d2
		move.b	(a6),d0
		and.b	#$f0,d0
		or.b	d0,d2
		tst.b	d2
		beq.w	mt_setregs
		moveq.l #0,d3
		lea.l	mt_samplestarts(pc),a1
		move	d2,d4
		subq.l	#1,d2
		add.l	d2,d2		; *= 4
		add.l	d2,d2
		mulu.w	#30,d4
		move.l	(a1,d2.l),n_start(a6)
		move.w	(a3,d4.l),n_length(a6)
		move.w	(a3,d4.l),n_reallength(a6)
		move.b	2(a3,d4.l),n_finetune(a6)
		move.b	3(a3,d4.l),n_volume(a6)
		move.w	4(a3,d4.l),d3	; Get repeat
		tst.w	d3
		beq.s	mt_noloop
		move.l	n_start(a6),d2	; Get start
		add.w	d3,d3
		add.l	d3,d2		; Add repeat
		move.l	d2,n_loopstart(a6)
		move.l	d2,n_wavestart(a6)
		move.w	4(a3,d4.l),d0	; Get repeat
		add.w	6(a3,d4.l),d0	; Add replen
		move.w	d0,n_length(a6)
		move.w	6(a3,d4.l),n_replen(a6)	; Save repeat len
		moveq.l #0,d0
		move.b	n_volume(a6),d0
		move.w	d0,mt_volume(a5)	; Set volume
		bra.s	mt_setregs

mt_noloop	move.l	n_start(a6),d2
		move.l	d2,n_loopstart(a6)
		move.l	d2,n_wavestart(a6)
		move.w	6(a3,d4.l),n_replen(a6) ; Save replen
		moveq.l #0,d0
		move.b	n_volume(a6),d0
		move.w	d0,mt_volume(a5)	; Set volume

mt_setregs	move.w	(a6),d0
		and.w	#$0fff,d0
		beq.w	mt_checkmoreefx		; No note?
		move.w	2(a6),d0
		and.w	#$0ff0,d0
		cmp.w	#$0e50,d0
		beq.s	mt_dosetfinetune
		move.b	2(a6),d0
		and.b	#$0f,d0
		cmp.b	#3,d0			; Toneportamento
		beq.s	mt_chktoneporta
		cmp.b	#5,d0
		beq.s	mt_chktoneporta
		cmp.b	#9,d0			; Sample offset
		bne.s	mt_setperiod
		bsr.w	mt_checkmoreefx
		bra.s	mt_setperiod

mt_dosetfinetune
		bsr.w	mt_setfinetune
		bra.s	mt_setperiod

mt_chktoneporta
		bsr.w	mt_settoneporta
		bra.w	mt_checkmoreefx

mt_setperiod	movem.l d0-d1/a0-a1,-(sp)
		move.w	(a6),d1
		and.w	#$0fff,d1
		lea.l	mt_periodtable(pc),a1
		moveq.l #0,d0
		moveq.l #36,d7
mt_ftuloop	cmp.w	(a1,d0.w),d1
		bhs.s	mt_ftufound
		addq.l	#2,d0
		dbra	d7,mt_ftuloop

mt_ftufound    	moveq.l #0,d1
		move.b	n_finetune(a6),d1
		mulu.w	#36*2,d1
		add.l	d1,a1
		move.w	(a1,d0.w),n_period(a6)
		movem.l (sp)+,d0-d1/a0-a1

		move.w	2(a6),d0
		and.w	#$0ff0,d0
		cmpi.w	#$0ed0,d0 		; Notedelay
		beq.w	mt_checkmoreefx

		btst.b	#2,n_wavecontrol(a6)
		bne.s	mt_vibnoc
		clr.b	n_vibratopos(a6)

mt_vibnoc      	btst.b	#6,n_wavecontrol(a6)
		bne.s	mt_trenoc
		clr.b	n_tremolopos(a6)

mt_trenoc	move.l	n_start(a6),mt_sample_point(a5)	; Set start
		moveq.l #0,d0
		move.w	n_length(a6),d0			; Set length
		add.l	d0,d0
		add.l	mt_sample_point(a5),d0
		move.l	d0,mt_sample_end(a5)
		move.l	n_loopstart(a6),d0
		cmp.l	mt_sample_point(a5),d0
		bne.s	.mt_set_loop
		moveq.l #0,d0

.mt_set_loop	move.l	d0,mt_loop_start(a5)
		move.w	n_period(a6),d0
		move.w	d0,mt_period(a5)	; Set period
		move.w	n_dmabit(a6),d0
		or.w	d0,mt_dmacontemp
		bra.w	mt_checkmoreefx

mt_setdma
mt_dskip	add.w	#16,mt_patternpos
		move.b	mt_pattdeltime,d0
		beq.s	mt_dskc
		move.b	d0,mt_pattdeltime2
		clr.b	mt_pattdeltime
mt_dskc tst.b	mt_pattdeltime2
		beq.s	mt_dska
		subq.b	#1,mt_pattdeltime2
		beq.s	mt_dska
		sub.w	#16,mt_patternpos
mt_dska tst.b	mt_pbreakflag
		beq.s	mt_nnpysk
		sf.b	mt_pbreakflag
		moveq.l #0,d0
		move.b	mt_pbreakpos(pc),d0
		clr.b	mt_pbreakpos
		lsl.w	#4,d0
		move.w	d0,mt_patternpos
mt_nnpysk	cmp.w	#1024,mt_patternpos
		blo.s	mt_nonewposyet

mt_nextposition	moveq.l #0,d0
		move.b	mt_pbreakpos(pc),d0
		lsl.w	#4,d0
		move.w	d0,mt_patternpos
		clr.b	mt_pbreakpos
		clr.b	mt_posjumpflag
		addq.b	#1,mt_songpos
		and.b	#$7f,mt_songpos
		move.b	mt_songpos(pc),d1
		move.l	mt_songdataptr(pc),a0
		cmp.b	950(a0),d1
		blo.s	mt_nonewposyet
		clr.b	mt_songpos

mt_nonewposyet	tst.b	mt_posjumpflag
		bne.s	mt_nextposition
		movem.l (sp)+,d0-d4/a0-a6
		rts

mt_checkefx	bsr.w	mt_updatefunk
		move.w	n_cmd(a6),d0
		and.w	#$0fff,d0
		beq.s	mt_pernop

		moveq.l	#$000f,d1
		move.b	n_cmd(a6),d0
		and.w	d0,d1
	ifeq	MACHINE
		add.w	d1,d1
		add.w	d1,d1
		move.l	.efx_jump(pc,d1.w),-(sp)
	else
		move.l	.efx_jump(pc,d1.w*4),-(sp)
	endc
		rts

.efx_jump	dc.l	mt_arpeggio
		dc.l	mt_portaup
		dc.l	mt_portadown
		dc.l	mt_toneportamento
		dc.l	mt_vibrato
		dc.l	mt_toneplusvolslide
		dc.l	mt_vibratoplusvolslide
		dc.l	setback
		dc.l	setback
		dc.l	setback
		dc.l	setback
		dc.l	setback
		dc.l	setback
		dc.l	setback
		dc.l	mt_e_commands
		dc.l	setback

setback		move.w	n_period(a6),mt_period(a5)
		cmp.b	#7,d0
		beq.w	mt_tremolo
		cmp.b	#$a,d0
		beq.w	mt_volumeslide

mt_return2	rts

mt_pernop	move.w	n_period(a6),mt_period(a5)
		rts

mt_arpeggio	moveq.l #0,d0
		move.b	mt_counter(pc),d0
		divs.w	#3,d0
		swap.w	d0
		cmp.w	#0,d0
		beq.s	mt_arpeggio2
		cmp.w	#2,d0
		beq.s	mt_arpeggio1
		moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		lsr.b	#4,d0
		bra.s	mt_arpeggio3

mt_arpeggio1	moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#15,d0
		bra.s	mt_arpeggio3

mt_arpeggio2	move.w	n_period(a6),d2
		bra.s	mt_arpeggio4

mt_arpeggio3	add.w	d0,d0
		moveq.l #0,d1
		move.b	n_finetune(a6),d1
		mulu.w	#36*2,d1

		lea.l	mt_periodtable(pc),a0
		add.l	d1,a0
		moveq.l #0,d1
		move.w	n_period(a6),d1
		moveq.l #36,d7

mt_arploop	move.w	(a0,d0.w),d2
		cmp.w	(a0),d1
		bhs.s	mt_arpeggio4
		addq.l	#2,a0
		dbra	d7,mt_arploop
		rts

mt_arpeggio4	move.w	d2,mt_period(a5)
		rts

mt_fineportaup	tst.b	mt_counter
		bne.s	mt_return2
		move.b	#$0f,mt_lowmask

mt_portaup	moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	mt_lowmask(pc),d0
		move.b	#$ff,mt_lowmask
		sub.w	d0,n_period(a6)
		move.w	n_period(a6),d0
		and.w	#$0fff,d0
		cmp.w	#113,d0
		bpl.s	mt_portauskip
		and.w	#$f000,n_period(a6)
		or.w	#113,n_period(a6)

mt_portauskip	move.w	n_period(a6),d0
		and.w	#$0fff,d0
		move.w	d0,mt_period(a5)
		rts

mt_fineportadown
		tst.b	mt_counter
		bne.w	mt_return2
		move.b	#$0f,mt_lowmask

mt_portadown	clr.w	d0
		move.b	n_cmdlo(a6),d0
		and.b	mt_lowmask(pc),d0
		move.b	#$ff,mt_lowmask
		add.w	d0,n_period(a6)
		move.w	n_period(a6),d0
		and.w	#$0fff,d0
		cmp.w	#856,d0
		bmi.s	mt_portadskip
		and.w	#$f000,n_period(a6)
		or.w	#856,n_period(a6)

mt_portadskip	move.w	n_period(a6),d0
		and.w	#$0fff,d0
		move.w	d0,mt_period(a5)
		rts

mt_settoneporta move.l	a0,-(sp)
		move.w	(a6),d2
		and.w	#$0fff,d2
		moveq.l #0,d0
		move.b	n_finetune(a6),d0
		mulu.w	#37*2,d0
		lea.l	mt_periodtable(pc),a0
		add.l	d0,a0
		moveq.l #0,d0

mt_stploop	cmp.w	(a0,d0.w),d2
		bhs.s	mt_stpfound
		addq.w	#2,d0
		cmp.w	#37*2,d0
		blo.s	mt_stploop
		moveq.l #35*2,d0

mt_stpfound	move.b	n_finetune(a6),d2
		and.b	#8,d2
		beq.s	mt_stpgoss
		tst.w	d0
		beq.s	mt_stpgoss
		subq.w	#2,d0

mt_stpgoss	move.w	(a0,d0.w),d2
		move.l	(sp)+,a0
		move.w	d2,n_wantedperiod(a6)
		move.w	n_period(a6),d0
		clr.b	n_toneportdirec(a6)
		cmp.w	d0,d2
		beq.s	mt_clea.lrtoneporta
		bge	mt_return2
		move.b	#1,n_toneportdirec(a6)
		rts

mt_clea.lrtoneporta
		clr.w	n_wantedperiod(a6)
		rts

mt_toneportamento
		move.b	n_cmdlo(a6),d0
		beq.s	mt_toneportnochange
		move.b	d0,n_toneportspeed(a6)
		clr.b	n_cmdlo(a6)
mt_toneportnochange
		tst.w	n_wantedperiod(a6)
		beq.w	mt_return2
		moveq.l #0,d0
		move.b	n_toneportspeed(a6),d0
		tst.b	n_toneportdirec(a6)
		bne.s	mt_toneportaup
mt_toneportadown
		add.w	d0,n_period(a6)
		move.w	n_wantedperiod(a6),d0
		cmp.w	n_period(a6),d0
		bgt.s	mt_toneportasetper
		move.w	n_wantedperiod(a6),n_period(a6)
		clr.w	n_wantedperiod(a6)
		bra.s	mt_toneportasetper

mt_toneportaup	sub.w	d0,n_period(a6)
		move.w	n_wantedperiod(a6),d0
		cmp.w	n_period(a6),d0
		blt.s	mt_toneportasetper
		move.w	n_wantedperiod(a6),n_period(a6)
		clr.w	n_wantedperiod(a6)

mt_toneportasetper
		move.w	n_period(a6),d2
		move.b	n_glissfunk(a6),d0
		and.b	#$0f,d0
		beq.s	mt_glissskip
		moveq.l #0,d0
		move.b	n_finetune(a6),d0
		mulu.w	#36*2,d0
		lea.l	mt_periodtable(pc),a0
		add.l	d0,a0
		moveq.l #0,d0

mt_glissloop	cmp.w	(a0,d0.w),d2
		bhs.s	mt_glissfound
		addq.w	#2,d0
		cmp.w	#36*2,d0
		blo.s	mt_glissloop
		moveq.l #35*2,d0

mt_glissfound 	move.w	(a0,d0.w),d2
mt_glissskip	move.w	d2,mt_period(a5)	; Set period
		rts

mt_vibrato	move.b	n_cmdlo(a6),d0
		beq.s	mt_vibrato2
		move.b	n_vibratocmd(a6),d2
		and.b	#$0f,d0
		beq.s	mt_vibskip
		and.b	#$f0,d2
		or.b	d0,d2

mt_vibskip	move.b	n_cmdlo(a6),d0
		and.b	#$f0,d0
		beq.s	mt_vibskip2
		and.b	#$0f,d2
		or.b	d0,d2

mt_vibskip2	move.b	d2,n_vibratocmd(a6)
mt_vibrato2	move.b	n_vibratopos(a6),d0
		lea.l	mt_vibratotable(pc),a4
		lsr.w	#2,d0
		and.w	#$001f,d0
		moveq.l #0,d2
		move.b	n_wavecontrol(a6),d2
		and.b	#$03,d2
		beq.s	mt_vib_sine
		lsl.b	#3,d0
		cmp.b	#1,d2
		beq.s	mt_vib_rampdown
		move.b	#255,d2
		bra.s	mt_vib_set

mt_vib_rampdown tst.b	n_vibratopos(a6)
		bpl.s	mt_vib_rampdown2
		move.b	#255,d2
		sub.b	d0,d2
		bra.s	mt_vib_set
mt_vib_rampdown2
		move.b	d0,d2
		bra.s	mt_vib_set

mt_vib_sine	move.b	0(a4,d0.w),d2

mt_vib_set	move.b	n_vibratocmd(a6),d0
		and.w	#15,d0
		mulu.w	d0,d2
		lsr.w	#7,d2
		move.w	n_period(a6),d0
		tst.b	n_vibratopos(a6)
		bmi.s	mt_vibratoneg
		add.w	d2,d0
		bra.s	mt_vibrato3
mt_vibratoneg	sub.w	d2,d0
mt_vibrato3	move.w	d0,mt_period(a5)
		move.b	n_vibratocmd(a6),d0
		lsr.w	#2,d0
		and.w	#$003c,d0
		add.b	d0,n_vibratopos(a6)
		rts

mt_toneplusvolslide
		bsr.w	mt_toneportnochange
		bra.w	mt_volumeslide

mt_vibratoplusvolslide
		bsr.s	mt_vibrato2
		bra.w	mt_volumeslide

mt_tremolo    	move.b	n_cmdlo(a6),d0
		beq.s	mt_tremolo2
		move.b	n_tremolocmd(a6),d2
		and.b	#$0f,d0
		beq.s	mt_treskip
		and.b	#$f0,d2
		or.b	d0,d2

mt_treskip	move.b	n_cmdlo(a6),d0
		and.b	#$f0,d0
		beq.s	mt_treskip2
		and.b	#$0f,d2
		or.b	d0,d2
mt_treskip2	move.b	d2,n_tremolocmd(a6)
mt_tremolo2	move.b	n_tremolopos(a6),d0
		lea.l	mt_vibratotable(pc),a4
		lsr.w	#2,d0
		and.w	#$001f,d0
		moveq.l #0,d2
		move.b	n_wavecontrol(a6),d2
		lsr.b	#4,d2
		and.b	#$03,d2
		beq.s	mt_tre_sine
		lsl.b	#3,d0
		cmp.b	#1,d2
		beq.s	mt_tre_rampdown
		move.b	#255,d2
		bra.s	mt_tre_set

mt_tre_rampdown tst.b	n_vibratopos(a6)
		bpl.s	mt_tre_rampdown2
		move.b	#255,d2
		sub.b	d0,d2
		bra.s	mt_tre_set
mt_tre_rampdown2
		move.b	d0,d2
		bra.s	mt_tre_set

mt_tre_sine	move.b	0(a4,d0.w),d2

mt_tre_set	move.b	n_tremolocmd(a6),d0
		and.w	#15,d0
		mulu.w	d0,d2
		lsr.w	#6,d2
		moveq.l #0,d0
		move.b	n_volume(a6),d0
		tst.b	n_tremolopos(a6)
		bmi.s	mt_tremoloneg
		add.w	d2,d0
		bra.s	mt_tremolo3
mt_tremoloneg	sub.w	d2,d0

mt_tremolo3	bpl.s	mt_tremoloskip
		clr.w	d0

mt_tremoloskip	cmp.w	#$40,d0
		bls.s	mt_tremolook
		move.w	#$40,d0

mt_tremolook	move.w	d0,mt_volume(a5)
		move.b	n_tremolocmd(a6),d0
		lsr.w	#2,d0
		and.w	#$003c,d0
		add.b	d0,n_tremolopos(a6)
		rts

mt_sampleoffset moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		beq.s	mt_sononew
		move.b	d0,n_sampleoffset(a6)

mt_sononew	move.b	n_sampleoffset(a6),d0
		lsl.w	#7,d0
		cmp.w	n_length(a6),d0
		bge.s	mt_sofskip
		sub.w	d0,n_length(a6)
		lsl.w	#1,d0
		add.l	d0,n_start(a6)
		add.l	n_loopstart(a6),d0
		cmp.l	n_start(a6),d0
		ble.s	.mt_set_loop
		move.l	n_loopstart(a6),d0
.mt_set_loop	move.l	d0,n_loopstart(a6)
		rts
mt_sofskip	move.w	#$0001,n_length(a6)
		rts

mt_volumeslide	moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		lsr.b	#4,d0
		tst.b	d0
		beq.s	mt_volslidedown

mt_volslideup	add.b	d0,n_volume(a6)
		cmp.b	#$40,n_volume(a6)
		bmi.s	mt_vsuskip
		move.b	#$40,n_volume(a6)

mt_vsuskip     	move.b	n_volume(a6),d0
		move.w	d0,mt_volume(a5)
		rts

mt_volslidedown moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
mt_volslidedown2
		sub.b	d0,n_volume(a6)
		bpl.s	mt_vsdskip
		clr.b	n_volume(a6)

mt_vsdskip	move.b	n_volume(a6),d0
		move.w	d0,mt_volume(a5)
		rts

mt_positionjump	move.b	n_cmdlo(a6),d0
		subq.b	#1,d0
		move.b	d0,mt_songpos
mt_pj2		clr.b	mt_pbreakpos
		st	mt_posjumpflag
		rts

mt_volumechange moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		cmp.b	#$40,d0
		bls.s	mt_volumeok
		moveq.l #$40,d0

mt_volumeok	move.b	d0,n_volume(a6)
		move.w	d0,mt_volume(a5)
		rts

mt_patternbreak moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		move.l	d0,d2
		lsr.b	#4,d0
		mulu.w	#10,d0
		and.b	#$0f,d2
		add.b	d2,d0
		cmp.b	#63,d0
		bhi.s	mt_pj2
		move.b	d0,mt_pbreakpos
		st.b	mt_posjumpflag
		rts

mt_setspeed	move.b	3(a6),d0
		beq.w	mt_return2
		clr.b	mt_counter
		move.b	d0,mt_speed
		rts

mt_checkmoreefx bsr.w	mt_updatefunk
		move.b	2(a6),d0
		andi.w	#$0f,d0
	ifeq	MACHINE
		add.w	d0,d0
		add.w	d0,d0
		move.l	.funk_jump(pc,d0.w),-(sp)
	else
		move.l	.funk_jump(pc,d0.w*4),-(sp)
	endc
		rts

.funk_jump	dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_pernop
		dc.l	mt_sampleoffset
		dc.l	mt_pernop
		dc.l	mt_positionjump
		dc.l	mt_volumechange
		dc.l	mt_patternbreak
		dc.l	mt_e_commands
		dc.l	mt_setspeed


mt_e_commands	moveq.l	#0,d0			; Optimized command processing to use
		move.b	n_cmdlo(a6),d0		; a jumptable

	ifeq	MACHINE
		add.w	d0,d0
		add.w	d0,d0
		move.l	.cmd_jump(pc,d0.l),-(sp)
	else
		move.l	.cmd_jump(pc,d0.l*4),-(sp)
	endc
		rts

.cmd_jump	dc.l	mt_filteronoff
		dc.l	mt_fineportaup
		dc.l	mt_fineportadown
		dc.l	mt_setglisscontrol
		dc.l	mt_setvibratocontrol
		dc.l	mt_setfinetune
		dc.l	mt_jumploop
		dc.l	mt_settremolocontrol
		dc.l	mt_user_cmd		; Cmd 0x08 (user defineable)
		dc.l	mt_retrignote
		dc.l	mt_volumefineup
		dc.l	mt_volumefinedown
		dc.l	mt_notecut
		dc.l	mt_notedelay
		dc.l	mt_patterndelay
		dc.l	mt_funkit

mt_user_cmd
mt_filteronoff	rts

mt_setglisscontrol
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		and.b	#$f0,n_glissfunk(a6)
		or.b	d0,n_glissfunk(a6)
		rts

mt_setvibratocontrol
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		and.b	#$f0,n_wavecontrol(a6)
		or.b	d0,n_wavecontrol(a6)
		rts

mt_setfinetune	move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		move.b	d0,n_finetune(a6)
		rts

mt_jumploop	tst.b	mt_counter
		bne.w	mt_return2
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		beq.s	mt_setloop
		tst.b	n_loopcount(a6)
		beq.s	mt_jumpcnt
		subq.b	#1,n_loopcount(a6)
		beq.w	mt_return2
mt_jmploop	move.b	n_pattpos(a6),mt_pbreakpos
		st.b	mt_pbreakflag
		rts

mt_jumpcnt	move.b	d0,n_loopcount(a6)
		bra.s	mt_jmploop

mt_setloop	move.w	mt_patternpos(pc),d0
		lsr.w	#4,d0
		move.b	d0,n_pattpos(a6)
		rts

mt_settremolocontrol
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		lsl.b	#4,d0
		and.b	#$0f,n_wavecontrol(a6)
		or.b	d0,n_wavecontrol(a6)
		rts

mt_retrignote	move.l	d1,-(sp)
		moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		beq.s	mt_rtnend
		moveq.l #0,d1
		move.b	mt_counter(pc),d1
		bne.s	mt_rtnskp
		move.w	(a6),d1
		and.w	#$0fff,d1
		bne.s	mt_rtnend
		moveq.l #0,d1
		move.b	mt_counter(pc),d1
mt_rtnskp	divu.w	d0,d1
		swap.w	d1
		tst.w	d1
		bne.s	mt_rtnend

mt_doretrig	move.l	n_start(a6),mt_sample_point(a5)	; Set sample data pointer
		moveq.l #0,d0
		move.w	n_length(a6),d0			; Set length
		add.l	d0,d0
		add.l	mt_sample_point(a5),d0
		move.l	d0,mt_sample_end(a5)

		move.l	n_loopstart(a6),d0
		cmp.l	mt_sample_point(a5),d0
		bne.s	.mt_set_loop
		moveq.l #0,d0
.mt_set_loop	move.l	d0,mt_loop_start(a5)

mt_rtnend	move.l	(sp)+,d1
		rts

mt_volumefineup tst.b	mt_counter
		bne.w	mt_return2
		moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$f,d0
		bra.w	mt_volslideup

mt_volumefinedown
		tst.b	mt_counter
		bne.w	mt_return2
		moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		bra.w	mt_volslidedown2

mt_notecut	moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		cmp.b	mt_counter(pc),d0
		bne.w	mt_return2
		clr.b	n_volume(a6)
		move.w	#0,mt_volume(a5)
		rts

mt_notedelay	moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		cmp.b	mt_counter,d0
		bne.w	mt_return2
		move.w	(a6),d0
		beq.w	mt_return2
		move.l	d1,-(sp)
		bra.w	mt_doretrig

mt_patterndelay tst.b	mt_counter
		bne.w	mt_return2
		moveq.l #0,d0
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		tst.b	mt_pattdeltime2
		bne.w	mt_return2
		addq.b	#1,d0
		move.b	d0,mt_pattdeltime
		rts

mt_funkit	tst.b	mt_counter
		bne.w	mt_return2
		move.b	n_cmdlo(a6),d0
		and.b	#$0f,d0
		lsl.b	#4,d0
		and.b	#$0f,n_glissfunk(a6)
		or.b	d0,n_glissfunk(a6)
		tst.b	d0
		beq.w	mt_return2

mt_updatefunk	movem.l a0/d1,-(sp)
		moveq.l #0,d0
		move.b	n_glissfunk(a6),d0
		lsr.b	#4,d0
		beq.s	mt_funkend
		lea.l	mt_funktable(pc),a0
		move.b	(a0,d0.w),d0
		add.b	d0,n_funkoffset(a6)
		btst	#7,n_funkoffset(a6)
		beq.s	mt_funkend
		clr.b	n_funkoffset(a6)

		move.l	n_loopstart(a6),d0
		moveq.l #0,d1
		move.w	n_replen(a6),d1
		add.l	d1,d0
		add.l	d1,d0
		move.l	n_wavestart(a6),a0
		addq.l	#1,a0
		cmp.l	d0,a0
		blo.s	mt_funkok
		move.l	n_loopstart(a6),a0

mt_funkok	move.l	a0,n_wavestart(a6)
		moveq.l #-1,d0
		sub.b	(a0),d0
		move.b	d0,(a0)

mt_funkend	movem.l (sp)+,a0/d1
		rts


; Replayer initialization routine

mt_init_Paula	bsr.s	mt_make_freq
		bsr.w	mt_make_tables
		bsr.w	mt_make_frame_f
		bsr.w	mt_make_voltab
		bsr.w	mt_make_divtab
		bsr.w	mt_make_mixcode

.mt_init_trap0	lea.l	mt_save_trap0,a0
		move.l	$80.w,(a0)
		lea.l	mt_return_Paula,a0
		move.l	a0,$80.w
		rts

mt_make_freq	move.l	mt_freq_list,a0
		moveq.l #3,d0
.mt_maker	move.l	d0,d1
		swap.w	d1
		divu.w	#40,d1
		move.w	d1,d2
		swap.w	d1
		cmp.w	#20,d1
		blt.s	.mt_no_round
		addq.w	#1,d2

.mt_no_round	moveq.l #0,d1
		moveq.l #0,d3
		moveq.l #0,d4
		moveq.l #0,d5
		moveq.l #39,d7
.mt_make_freq	add.w	d2,d1
		negx.w	d4
		neg.w	d4
		move.w	d4,d5
		move.w	d1,d6
		add.w	d6,d6
		negx.w	d5
		neg.w	d5
		cmp.w	d3,d5
		ble.s	.mt_set_zero
		move.w	d5,d3
		moveq.l #1,d5
		move.w	d5,(a0)+
		dbra	d7,.mt_make_freq
		addq.w	#1,d0
		cmp.w	#26,d0
		bne.s	.mt_maker
		rts
.mt_set_zero	moveq.l #0,d5
		move.w	d5,(a0)+
		dbra	d7,.mt_make_freq
		addq.w	#1,d0
		cmp.w	#26,d0
		bne.s	.mt_maker
		rts

mt_make_tables	move.l	mt_freq_table,a0
		moveq.l #$72-1,d7
		move.l	#$02260000,d0
.mt_make_first	move.l	d0,(a0)+
		dbra	d7,.mt_make_first

		moveq.l #$72,d0
.mt_maker	move.l	mt_amiga_freq,d1
		move.w	d0,d2
		add.w	d2,d2
		divu.w	d2,d1
		moveq.l #0,d2
		moveq.l #0,d3
		move.w	d1,d2
		swap.w	d1
		cmp.w	d0,d1
		blt.s	.mt_no_round
		addq.w	#1,d2
.mt_no_round	divu.w	#50,d2
		move.w	d2,d1
		clr.w	d2
		divu.w	#50,d2
		move.l	d2,d3
		swap.w	d3
		cmp.w	#50/2,d3
		blt.s	.mt_no_round1
		addq.w	#1,d2
.mt_no_round1	sub.w	#75,d1
		bpl.s	.mt_no_zero
		moveq.l #0,d1
		moveq.l #0,d2
.mt_no_zero	move.w	d1,(a0)+
		move.w	d2,(a0)+
		addq.w	#1,d0
		cmp.w	#$400,d0
		bne.s	.mt_maker
		rts
mt_make_frame_f move.l	mt_frame_freq_t,a0
		move.l	mt_frame_freq_p,a1
		moveq.l #75,d0
.mt_maker	move.l	d0,d1
		divu.w	#25,d1
		moveq.l #0,d3
		move.w	d1,d2
		subq.w	#3,d2
		clr.w	d1
		divu.w	#25,d1
		move.w	d1,d3
		addq.w	#1,d3
.mt_no_round	move.l	a0,(a1)+
		moveq.l #0,d4
		moveq.l #24,d7
		moveq.l #0,d1
.mt_make_it	moveq.l #0,d1
		add.w	d3,d4
		addx.w	d2,d1
		move.w	d1,d5
		mulu.w	#23<<7,d5
		add.w	d1,d1
		add.w	d1,d1
		or.w	d1,d5
		move.w	d5,(a0)+
		dbra	d7,.mt_make_it
		addq.w	#1,d0
		cmp.w	#626,d0
		bne.s	.mt_maker
		rts
mt_make_voltab	lea.l	mt_volume_tab,a0
		move.l	(a0),d0
		andi.w	#$ff00,d0
		add.l	#$100,d0
		move.l	d0,(a0)
		move.l	d0,a0
		moveq.l #0,d0
		moveq.l #0,d1
		moveq.l #0,d3
.mt_clop0	move.w	d1,d2
		ext.w	d2
		muls.w	d0,d2
		asr.w	#6,d2
		move.b	d2,(a0)+
		addq.w	#1,d1
		cmp.w	#$40,d1
		bne.s	.mt_clop0
		lea.l	$80(a0),a0
		move.w	#$c0,d1
.mt_clop1	move.w	d1,d2
		ext.w	d2
		muls.w	d0,d2
		asr.w	#6,d2
		move.b	d2,(a0)+
		addq.w	#1,d1
		cmp.w	#$100,d1
		bne.s	.mt_clop1

		moveq.l #0,d1
		addq.w	#1,d0
		cmp.w	#$41,d0
		bne.s	.mt_clop0
		rts

mt_make_divtab	moveq.l #1,d0
		moveq.l #1,d1
		move.l	mt_div_table,a0
.mt_init_div	move.l	d1,d2
		asl.w	#6,d2
		move.w	d0,d3
		divu.w	d0,d2
		lsr.w	#1,d3
		negx.w	d3
		neg.w	d3
		move.w	d2,d4
		swap.w	d2
		cmp.w	d3,d2
		blt.s	.mt_no_round
		addq.w	#1,d4
.mt_no_round	move.w	d4,(a0)+
		addq.w	#1,d0
		cmp.w	#$41,d0
		bne.s	.mt_init_div
		moveq.l #1,d0
		addq.w	#1,d1
		cmp.w	#$41,d1
		bne.s	.mt_init_div
		rts

mt_make_mixcode move.l	mt_mixcode_p,a0
		move.l	mt_mixer_chunk,a1
		move.l	mt_freq_list,a2
		lea.l	(a2),a4
		moveq.l #22,d7
		moveq.l #22,d6
.mt_maker	move.l	a1,(a0)+
		lea.l	(a2),a3
		moveq.l #40-1,d5
.mt_make_it	move.w	.mt_copy,(a1)+
		move.w	(a3)+,d0
		move.w	(a4)+,d1
		add.w	d1,d1
		or.w	d1,d0
		dbne	d5,.mt_make_it
		tst.w	d5
		beq.s	.mt_end_ops
		bpl.s	.mt_no_exit
.mt_make_end	move.w	#$4ed6,(a1)+
		dbra	d6,.mt_maker
		moveq.l #22,d6
		lea.l	80(a2),a2
		move.l	mt_freq_list,a4
		dbra	d7,.mt_maker
		rts

.mt_no_exit  	move.l	a3,-(sp)
		move.l	a4,-(sp)
		move.w	d5,d4
		subq.w	#1,d4
.mt_analyse	move.w	(a3)+,d1
		move.w	(a4)+,d2
		add.w	d2,d2
		or.w	d2,d1
	ifeq	MACHINE
		add.w	d1,d1 				  ; opt hint: use scaled 030 indexing
		add.w	d1,d1
		move.l	.mt_ana_code(pc,d1.w),a6
	else
		move.l	.mt_ana_code(pc,d1.w*4),a6
	endc
		jsr	(a6)
		dbra	d4,.mt_analyse
		move.l	(sp)+,a4
		move.l	(sp)+,a3
		tst.w	d1
		dbeq	d5,.mt_make_it
		bra.s	.mt_end_ops

.mt_ana_code	dc.l	.mt_ana_code0
		dc.l	.mt_ana_code1
		dc.l	.mt_ana_code2
		dc.l	.mt_ana_code3

.mt_end_ops	cmp.w	#3,d0
		beq.s	.mt_ana_code03
		cmp.w	#2,d0
		beq.s	.mt_ana_code02
.mt_ana_code01	lea.l	.mt_copy,a6
		move.w	.mt_copy2,(a6)
		move.w	.mt_ch0_fetch,(a1)+
		move.l	.mt_add012,(a1)+
		dbra	d5,.mt_make_it
		move.w	#$4ed6,(a1)+
		dbra	d6,.mt_maker
		moveq.l #22,d6
		lea.l	80(a2),a2
		move.l	mt_freq_list,a4
		dbra	d7,.mt_maker
		rts
.mt_ana_code02	lea.l	.mt_copy,a6
		move.w	.mt_copy2,(a6)
		move.w	.mt_ch1_fetch,(a1)+
		move.l	.mt_ch1_fetch+2,(a1)+
		move.l	.mt_add012,(a1)+
		dbra	d5,.mt_make_it
		move.w	#$4ed6,(a1)+
		dbra	d6,.mt_maker
		moveq.l #22,d6
		lea.l	80(a2),a2
		move.l	mt_freq_list,a4
		dbra	d7,.mt_maker
		rts
.mt_ana_code03	lea.l	.mt_copy,a6
		move.w	.mt_copy2,(a6)
		move.l	.mt_ch01fetadd1,(a1)+
		move.l	.mt_ch01fetadd1+4,(a1)+
		move.l	.mt_add012,(a1)+
		dbra	d5,.mt_make_it
		move.w	#$4ed6,(a1)+
		dbra	d6,.mt_maker
		moveq.l #22,d6
		lea.l	80(a2),a2
		move.l	mt_freq_list,a4
		dbra	d7,.mt_maker
		rts

.mt_ana_code0	rts
.mt_ana_code1	cmp.w	#3,d0
		beq.s	.mt_ana_code13
		cmp.w	#2,d0
		beq.s	.mt_ana_code12
.mt_ana_code11	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy0,(a6)
		move.w	.mt_ch0_fetch,(a1)+
		move.w	.mt_add10,(a1)+
		rts
.mt_ana_code12	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy0,(a6)
		move.w	.mt_ch1_fetch,(a1)+
		move.l	.mt_ch1_fetch+2,(a1)+
		move.w	.mt_add10,(a1)+
		rts
.mt_ana_code13	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy0,(a6)
		move.l	.mt_ch01fetadd1,(a1)+
		move.l	.mt_ch01fetadd1+4,(a1)+
		move.w	.mt_add10,(a1)+
		rts

.mt_ana_code2	cmp.w	#3,d0
		beq.s	.mt_ana_code23
		cmp.w	#2,d0
		beq.s	.mt_ana_code22
.mt_ana_code21	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy1,(a6)
		move.w	.mt_ch0_fetch,(a1)+
		move.w	.mt_add01,(a1)+
		rts

.mt_ana_code22	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy1,(a6)
		move.w	.mt_ch1_fetch,(a1)+
		move.l	.mt_ch1_fetch+2,(a1)+
		move.w	.mt_add01,(a1)+
		rts
		rts

.mt_ana_code23	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy1,(a6)
		move.l	.mt_ch01fetadd1,(a1)+
		move.l	.mt_ch01fetadd1+4,(a1)+
		move.w	.mt_add01,(a1)+
		rts

.mt_ana_code3	cmp.w	#3,d0
		beq.s	.mt_ana_code33
		cmp.w	#2,d0
		beq.s	.mt_ana_code32
.mt_ama_code31	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy1,(a6)
		move.w	.mt_ch0_fet_add,(a1)+
		rts

.mt_ana_code32	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy0,(a6)
		move.w	.mt_ch1_fet_add,(a1)+
		move.l	.mt_ch1_fet_add+2,(a1)+
		rts

.mt_ana_code33	moveq.l #0,d4
		moveq.l #1,d1
		lea.l	.mt_copy,a6
		move.w	.mt_copy0,(a6)
		move.l	.mt_ch01fetadd0,(a1)+
		move.l	.mt_ch01fetadd0+4,(a1)+
		rts

.mt_copy	move.b	d2,(sp)+
.mt_copy0	move.b	d0,(sp)+
.mt_copy1	move.b	d1,(sp)+
.mt_copy2	move.b	d2,(sp)+

.mt_ch0_fetch	move.b	(a0)+,d0
.mt_ch0_fet_add add.b	(a0)+,d1
.mt_ch1_fetch	move.b	(a1)+,d1
		move.l	d1,a2
		move.b	(a2),d1
.mt_ch1_fet_add move.b	(a1)+,d1
		move.l	d1,a2
		add.b	(a2),d0
.mt_ch01fetadd0 move.b	(a0)+,d0
		move.b	(a1)+,d1
		move.l	d1,a2
		add.b	(a2),d0
.mt_ch01fetadd1 move.b	(a0)+,d0
		move.b	(a1)+,d1
		move.l	d1,a2
		move.b	(a2),d1
.mt_add01	add.b	d0,d1
.mt_add10	add.b	d1,d0
.mt_add012	move.b	d0,d2
		add.b	d1,d2

mt_stop_Paula	move.l	mt_save_trap0,$80.w

		move.w	mt_LCM_mask,d0
		move.w	mt_LCM_left,d1
		or.w	#20,d1
		bsr.s	.mt_set_LCM
		move.w	mt_LCM_right,d1
		or.w	#20,d1

mt_end	=	mt_stop_Paula


.mt_set_LCM	lea.l	$ffff8900.w,a6
		move.w	d0,$24(a6)
		move.w	d1,$22(a6)
		rept	16
		nop
		endr
.mt_LCM_loop	cmp.w	$24(a6),d0
		bne.s	.mt_LCM_loop
		rts

mt_Paula	lea.l	$ffff8900.w,a6
		move.l	mt_LCM_set,a0

	ifeq	MACHINE 			; TT fix by ray//.tSCc., 2003
		jmp	(a0)
	else
		move.l	sp,mt_save_SP
		jsr	(a0)
	endc

mt_return_Paula	lea.l	mt_physic_buf,a0
		lea.l	mt_logic_buf,a1
		move.l	(a0),d0
		move.l	(a1),(a0)
		move.l	d0,(a1)

	ifeq	MACHINE
		movea.l	mt_save_SSP(pc),sp
	else
		movea.l	mt_save_SP(pc),sp
	endc
		rts


		rsreset
mt_temp_regs	rs.l	2
mt_temp_old_sam rs.w	2

mt_channel	macro
		move.l	(a3),d0
		bne.s	.mt_v0_active
		lea.l	mt_dummy_tab,a3
.mt_v0_active	move.l	(a4),d0
		bne.s	.mt_v1_active
		lea.l	mt_dummy_tab,a4
.mt_v1_active	move.w	mt_volume(a3),d0
		cmp.w	mt_volume(a4),d0
		bge.s	.mt_no_swap
		exg	a3,a4
.mt_no_swap	move.w	mt_volume(a3),d0
		moveq.l #0,d1
		move.w	d0,(a1)
		beq.s	.mt_set_zero
		move.w	mt_volume(a4),d1
		beq.s	.mt_set_zero
		subq.w	#1,d0
		subq.w	#1,d1
		andi.w	#$3f,d0
		andi.w	#$3f,d1
		asl.w	#6,d1
		or.w	d0,d1
		movea.l	mt_div_table,a1
	ifeq	MACHINE
		add.w	d1,d1
		move.w	(a1,d1.w),d1
	else
		move.w	(a1,d1.w*2),d1
	endc
	
.mt_set_zero	move.l	mt_volume_tab,a1
		asl.w	#8,d1
		add.l	a1,d1
		move.l	mt_sample_point(a3),a0
		move.l	mt_sample_point(a4),a1
		lea.l	mt_temp_old_sam(a6),a2
		move.b	(a2)+,d0
		move.b	(a2)+,d1
		move.b	(a2)+,d2

		move.w	mt_period(a3),d3
		move.l	mt_freq_table,a2
	ifeq	MACHINE
		add.w	d3,d3
		add.w	d3,d3
		move.l	(a2,d3.w),d3
	else
		move.l	(a2,d3.w*4),d3
	endc
		move.w	d3,d4
		swap.w	d3
		add.w	mt_add_iw(a3),d4
		negx.w	d3
		neg.w	d3
		move.w	d4,mt_add_iw(a3)

		move.w	mt_period(a4),d4
		add.w	d4,d4
		add.w	d4,d4
		move.l	(a2,d4.w),d4
		move.w	d4,d5
		swap.w	d4
		add.w	mt_add_iw(a4),d5
		negx.w	d4
		neg.w	d4
		move.w	d5,mt_add_iw(a4)

		move.l	mt_frame_freq_p,a2
	ifeq	MACHINE
		add.w	d3,d3
		add.w	d3,d3
		move.l	(a2,d3.w),d3
		add.w	d4,d4
		add.w	d4,d4
		move.l	(a2,d4.w),d4
	else
		move.l	(a2,d3.w*4),d3
		move.l	(a2,d4.w*4),d4
	endc

		move.l	a3,(a6)+
		move.l	a4,(a6)+
		move.l	d3,a3
		move.l	d4,a4
		move.l	mt_mixcode_p,a5
		moveq.l #$1f<<2,d5
		move.w	#$1ff<<7,d6
		move.l	a6,d7

		lea.l	.mt_return,a6
		move.w	(a3)+,d3
		move.w	(a4)+,d4
		and.w	d5,d4
		and.w	d6,d3
		lsr.w	#5,d3
		add.w	d3,d4
		move.l	(a5,d4.w),a2
		jmp	(a2)

.mt_return 	rept	24
		lea.l	$16(a6),a6
		move.w	(a3)+,d3
		move.w	(a4)+,d4
		and.w	d5,d4
		and.w	d6,d3
		lsr.w	#5,d3
		add.w	d3,d4
		move.l	(a5,d4.w),a2
		jmp	(a2)
		endr

		move.l	d7,a6
		move.l	-(a6),a4
		move.l	-(a6),a3
		lea.l	mt_temp_old_sam(a6),a2
		move.b	d0,(a2)+
		move.b	d1,(a2)+
		move.b	d2,(a2)+

		move.l	a0,mt_sample_point(a3)
		cmp.l	mt_sample_end(a3),a0
		blt.s	.mt_no_end_v0
		move.l	mt_loop_start(a3),d0
		beq.s	.mt_no_loop_v0
		move.l	a0,d1
		sub.l	mt_sample_end(a3),d1
		neg.l	d0
		add.l	mt_sample_end(a3),d0
		divu.w	d0,d1
		clr.w	d1
		swap.w	d1
		add.l	mt_loop_start(a3),d1
		move.l	d1,mt_sample_point(a3)
		bra.s	.mt_no_end_v0

.mt_no_loop_v0	move.w	mt_check_dummy(a3),d2
		bne.s	.mt_no_end_v0
		moveq.l #0,d2
		move.l	d2,(a3)+
		move.l	d2,(a3)+
		move.l	d2,(a3)+
		move.l	d2,(a3)+
		move.l	d2,(a3)+

.mt_no_end_v0 	move.l	a1,mt_sample_point(a4)
		cmp.l	mt_sample_end(a4),a1
		blt.s	.mt_no_end_v1
		move.l	mt_loop_start(a4),d0
		beq.s	.mt_no_loop_v1
		move.l	a1,d1
		sub.l	mt_sample_end(a4),d1
		neg.l	d0
		add.l	mt_sample_end(a4),d0
		divu.w	d0,d1
		clr.w	d1
		swap.w	d1
		add.l	mt_loop_start(a4),d1
		move.l	d1,mt_sample_point(a4)
		bra.s	.mt_no_end_v1

.mt_no_loop_v1	move.w	mt_check_dummy(a4),d2
		bne.s	.mt_no_end_v1
		moveq.l #0,d2
		move.l	d2,(a4)+
		move.l	d2,(a4)+
		move.l	d2,(a4)+
		move.l	d2,(a4)+
		move.l	d2,(a4)+
.mt_no_end_v1	lea.l	mt_dummy_tab,a3
		move.l	4(a3),(a3)
		endm


mt_emulate	lea.l	mt_save_USP,a0
		move.l	sp,(a0)

		lea.l	mt_channel_p,a0
		lea.l	mt_left_volume,a1
		lea.l	mt_left_temp,a6
		move.l	mt_logic_buf,sp
		move.l	0(a0),a3
		move.l	$c(a0),a4
mt_channel03	mt_channel

		lea.l	mt_channel_p,a0
		lea.l	mt_right_volume,a1
		lea.l	mt_right_temp,a6
		move.l	mt_logic_buf,sp
		lea.l	1(sp),sp
		move.l	4(a0),a3
		move.l	8(a0),a4

mt_channel12	mt_channel

mt_check_vols	lea.l	mt_left_volume,a0
		lea.l	mt_left_volold,a1
		move.w	(a0)+,d0
		cmp.w	(a1),d0
		sne.b	d1
		andi.w	#$4,d1
		move.w	d0,(a1)+
		move.w	(a0)+,d0
		cmp.w	(a1),d0
		sne.b	d2
		andi.w	#$8,d2
		or.w	d2,d1
		move.w	d0,(a1)+
		lea.l	mt_LCM_set,a0
		move.l	mt_LCM_set_conf(pc,d1.w),(a0)

		move.l	mt_save_USP,sp
		trap	#0

mt_LCM_set_conf dc.l	mt_set_left		; For timing only
		dc.l	mt_set_left
		dc.l	mt_set_right
		dc.l	mt_set_all

mt_set_left	move.w	mt_LCM_mask,$24(a6)
		move.w	mt_left_volume,d0
		
	ifeq	MACHINE
		add.w	d0,d0
		move.w	.mt_LCM_vol_tab(pc,d0.w),d0
	else
		move.w	.mt_LCM_vol_tab(pc,d0.w*2),d0
	endc
		or.w	mt_LCM_left,d0
		move.w	d0,$22(a6)
		move.l	mt_physic_buf,d0
		movep.l d0,$1(a6)
		add.l	mt_replay_len,d0
		movep.l d0,$d(a6)
		move.w	mt_frequency,$20(a6)
		move.w	mt_start,(a6)

		lea.l	mt_save_SSP,a0
		move.l	sp,(a0)
		pea.l	mt_emulate
		move.w	sr,d0
		andi.w	#$fff,d0
		move.w	d0,-(sp)
		rte
.mt_LCM_vol_tab dc.w	0
		dc.w	2,5,7,8,9,10,10,11,11,12,12,13,13,13,14,14
		dc.w	14,14,15,15,15,15,16,16,16,16,16,16,17,17,17,17
		dc.w	17,17,17,18,18,18,18,18,18,18,18,18,18,19,19,19
		dc.w	19,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20

mt_set_right	move.w	mt_LCM_mask,$24(a6)
		move.w	mt_right_volume,d0

	ifeq	MACHINE
		add.w	d0,d0
		move.w	.mt_LCM_vol_tab(pc,d0.w),d0
	else
		move.w	.mt_LCM_vol_tab(pc,d0.w*2),d0
	endc
		or.w	mt_LCM_right,d0
		move.w	d0,$22(a6)
		move.l	mt_physic_buf,d0
		movep.l d0,$1(a6)
		add.l	mt_replay_len,d0
		movep.l d0,$d(a6)
		move.w	mt_frequency,$20(a6)
		move.w	mt_start,(a6)

		lea.l	mt_save_SSP,a0
		move.l	sp,(a0)
		pea.l	mt_emulate
		move.w	sr,d0
		andi.w	#$fff,d0
		move.w	d0,-(sp)
		rte
.mt_LCM_vol_tab dc.w	0
		dc.w	2,5,7,8,9,10,10,11,11,12,12,13,13,13,14,14
		dc.w	14,14,15,15,15,15,16,16,16,16,16,16,17,17,17,17
		dc.w	17,17,17,18,18,18,18,18,18,18,18,18,18,19,19,19
		dc.w	19,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20

mt_set_all	move.w	mt_LCM_mask,$24(a6)
		move.w	mt_left_volume,d0

	ifeq	MACHINE
		add.w	d0,d0
		move.w	.mt_LCM_vol_tab(pc,d0.w),d0
	else
		move.w	.mt_LCM_vol_tab(pc,d0.w*2),d0	
	endc
		or.w	mt_LCM_left,d0
		move.w	d0,$22(a6)
		move.l	mt_physic_buf,d0
		movep.l d0,$1(a6)
		add.l	mt_replay_len,d0
		movep.l d0,$d(a6)
		move.w	mt_frequency,$20(a6)
		move.w	mt_start,(a6)
		move.w	mt_LCM_mask,d1
		move.w	mt_right_volume,d0
		add.w	d0,d0
		move.w	.mt_LCM_vol_tab(pc,d0.w),d0
		or.w	mt_LCM_right,d0
.mt_test_LCM	cmp.w	$24(a6),d1
		bne.s	.mt_test_LCM
		move.w	d0,$22(a6)

		lea.l	mt_save_SSP,a0
		move.l	sp,(a0)
		pea.l	mt_emulate
		move.w	sr,d0
		andi.w	#$fff,d0
		move.w	d0,-(sp)
		rte

.mt_LCM_vol_tab dc.w	0
		dc.w	2,5,7,8,9,10,10,11,11,12,12,13,13,13,14,14
		dc.w	14,14,15,15,15,15,16,16,16,16,16,16,17,17,17,17
		dc.w	17,17,17,18,18,18,18,18,18,18,18,18,18,19,19,19
		dc.w	19,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20

		section data
mt_funktable	dc.b	0,5,6,7,8,10,11,13,16,19,22,26,32,43,64,128

mt_vibratotable
		dc.b	0, 24, 49, 74, 97,120,141,161
		dc.b	180,197,212,224,235,244,250,253
		dc.b	255,253,250,244,235,224,212,197
		dc.b	180,161,141,120, 97, 74, 49, 24

mt_periodtable

; tuning 0, normal
		dc.w	856,808,762,720,678,640,604,570,538,508,480,453
		dc.w	428,404,381,360,339,320,302,285,269,254,240,226
		dc.w	214,202,190,180,170,160,151,143,135,127,120,113
; tuning 1
		dc.w	850,802,757,715,674,637,601,567,535,505,477,450
		dc.w	425,401,379,357,337,318,300,284,268,253,239,225
		dc.w	213,201,189,179,169,159,150,142,134,126,119,113
; tuning 2
		dc.w	844,796,752,709,670,632,597,563,532,502,474,447
		dc.w	422,398,376,355,335,316,298,282,266,251,237,224
		dc.w	211,199,188,177,167,158,149,141,133,125,118,112
; tuning 3
		dc.w	838,791,746,704,665,628,592,559,528,498,470,444
		dc.w	419,395,373,352,332,314,296,280,264,249,235,222
		dc.w	209,198,187,176,166,157,148,140,132,125,118,111
; tuning 4
		dc.w	832,785,741,699,660,623,588,555,524,495,467,441
		dc.w	416,392,370,350,330,312,294,278,262,247,233,220
		dc.w	208,196,185,175,165,156,147,139,131,124,117,110
; tuning 5
		dc.w	826,779,736,694,655,619,584,551,520,491,463,437
		dc.w	413,390,368,347,328,309,292,276,260,245,232,219
		dc.w	206,195,184,174,164,155,146,138,130,123,116,109
; tuning 6
		dc.w	820,774,730,689,651,614,580,547,516,487,460,434
		dc.w	410,387,365,345,325,307,290,274,258,244,230,217
		dc.w	205,193,183,172,163,154,145,137,129,122,115,109
; tuning 7
		dc.w	814,768,725,684,646,610,575,543,513,484,457,431
		dc.w	407,384,363,342,323,305,288,272,256,242,228,216
		dc.w	204,192,181,171,161,152,144,136,128,121,114,108
; tuning -8
		dc.w	907,856,808,762,720,678,640,604,570,538,508,480
		dc.w	453,428,404,381,360,339,320,302,285,269,254,240
		dc.w	226,214,202,190,180,170,160,151,143,135,127,120
; tuning -7
		dc.w	900,850,802,757,715,675,636,601,567,535,505,477
		dc.w	450,425,401,379,357,337,318,300,284,268,253,238
		dc.w	225,212,200,189,179,169,159,150,142,134,126,119
; tuning -6
		dc.w	894,844,796,752,709,670,632,597,563,532,502,474
		dc.w	447,422,398,376,355,335,316,298,282,266,251,237
		dc.w	223,211,199,188,177,167,158,149,141,133,125,118
; tuning -5
		dc.w	887,838,791,746,704,665,628,592,559,528,498,470
		dc.w	444,419,395,373,352,332,314,296,280,264,249,235
		dc.w	222,209,198,187,176,166,157,148,140,132,125,118
; tuning -4
		dc.w	881,832,785,741,699,660,623,588,555,524,494,467
		dc.w	441,416,392,370,350,330,312,294,278,262,247,233
		dc.w	220,208,196,185,175,165,156,147,139,131,123,117
; tuning -3
		dc.w	875,826,779,736,694,655,619,584,551,520,491,463
		dc.w	437,413,390,368,347,328,309,292,276,260,245,232
		dc.w	219,206,195,184,174,164,155,146,138,130,123,116
; tuning -2
		dc.w	868,820,774,730,689,651,614,580,547,516,487,460
		dc.w	434,410,387,365,345,325,307,290,274,258,244,230
		dc.w	217,205,193,183,172,163,154,145,137,129,122,115
; tuning -1
		dc.w	862,814,768,725,684,646,610,575,543,513,484,457
		dc.w	431,407,384,363,342,323,305,288,272,256,242,228
		dc.w	216,203,192,181,171,161,152,144,136,128,121,114

		dc.w	$416E,$6F74,$6865,$7220
		dc.w	$6772,$6561,$7420,$636F
		dc.w	$6465,$2062,$793A,$204C
		dc.w	$616E,$6365,$2000

mt_chan1temp	dc.l	0,0,0,0,$3ff0000,$00010000,0,0,0,0,0
mt_chan2temp	dc.l	0,0,0,0,$3ff0000,$00020000,0,0,0,0,0
mt_chan3temp	dc.l	0,0,0,0,$3ff0000,$00040000,0,0,0,0,0
mt_chan4temp	dc.l	0,0,0,0,$3ff0000,$00080000,0,0,0,0,0

mt_samplestarts dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

mt_songdataptr	dc.l	0
mt_module_end	dc.l	0

mt_speed		dc.b	6
mt_counter	dc.b	0
mt_songpos	dc.b	0
mt_pbreakpos	dc.b	0
mt_posjumpflag	dc.b	0
mt_pbreakflag	dc.b	0
mt_lowmask	dc.b	0
mt_pattdeltime	dc.b	0
mt_pattdeltime2 dc.b	0,0

mt_patternpos	dc.w	0
mt_dmacontemp	dc.w	0

mt_amiga_freq	dc.l	7090000
mt_freq_list	dc.l	mt_freqer_list
mt_freq_table	dc.l	mt_freq_tab
mt_volume_tab	dc.l	mt_vol_tab
mt_div_table	dc.l	mt_div_tab
mt_frame_freq_t dc.l	mt_frame_freq
mt_frame_freq_p dc.l	mt_frame_freqp
mt_mixcode_p	dc.l	mt_mixcodes
mt_mixer_chunk	dc.l	mt_mix_chunk
mt_channel_p	dc.l	mt_channel_0
		dc.l	mt_channel_1
		dc.l	mt_channel_2
		dc.l	mt_channel_3


mt_physic_buf	ds.l	1		; DMA Audio doublebuffer
mt_logic_buf	ds.l	1


mt_replay_len	dc.l	DMABUFLEN*2
mt_save_SSP	dc.l	0
mt_save_USP	dc.l	0
mt_save_SP	dc.l	0
mt_save_trap0	dc.l	0
mt_LCM_set	dc.l	mt_set_all
mt_start	dc.w	$0001
mt_frequency	dc.w	$0003
mt_left_volume	dc.w	0
mt_right_volume dc.w	0
mt_left_volold	dc.w	0
mt_right_volold dc.w	0
mt_LCM_mask	dc.w	$07ff
mt_LCM_left	dc.w	$540
mt_LCM_right	dc.w	$500
mt_left_temp	dc.l	0,0,0
mt_right_temp	dc.l	0,0,0

mt_channel_0	dc.l	0
		dc.l	0
		dc.l	0
		dc.w	0
		dc.w	$3ff
		dc.w	0
		dc.w	0

mt_channel_1	dc.l	0
		dc.l	0
		dc.l	0
		dc.w	0
		dc.w	$3ff
		dc.w	0
		dc.w	0

mt_channel_2	dc.l	0
		dc.l	0
		dc.l	0
		dc.w	0
		dc.w	$3ff
		dc.w	0
		dc.w	0

mt_channel_3	dc.l	0
		dc.l	0
		dc.l	0
		dc.w	0
		dc.w	$3ff
		dc.w	0
		dc.w	0

mt_dummy_tab	dc.l	mt_dummy_spl
		dc.l	mt_dummy_spl
		dc.l	0
		dc.w	0
		dc.w	$3ff
		dc.w	0
		dc.w	-1

******************************************************************************
mt_data incbin	'nomore.mod'	; The module
		ds.w	31*640/2
******************************************************************************

		section bss
mt_freqer_list	ds.w	23*40
mt_freq_tab	ds.l	$400
mt_vol_tab	ds.w	$4200/2
mt_div_tab	ds.w	$1000
mt_dummy_spl	ds.w	320
mt_frame_freqp	ds.l	551
mt_mixcodes	ds.l	529

mt_frame_freq	ds.w	27500
mt_mix_chunk	ds.w	60877
